document.addEventListener('deviceready', onDeviceReady, false);
document.addEventListener("backbutton", onBackKeyDown, false);

var exitAppTicker = 0;
var inAppBrowserRef;

function onDeviceReady() {
  initAPNSPush();
  StatusBar.styleDefault();
  document.getElementById('deviceready').classList.add('ready');

}

function initAPNSPush(){
  var u = navigator.userAgent;
  // const isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; // android终端
  var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); // ios终端
  if(isiOS){
    // 初始化应用
    const push = PushNotification.init({
      android: {},
      browser: {},
      ios: {
        alert: true,
        badge: true,
        sound: true
      },
      windows: {}
    });
    // 注册token
    push.on('registration', data => {
      window.localStorage.setItem('zf-ios-device-token', data.registrationId);
    });
  }
}


function getNotificationEvent() {
  var u = navigator.userAgent;
  // const isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; // android终端
  var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); // ios终端
  if (isiOS) {
    const pushNotification = window.plugins?.pushNotification;
    if (!pushNotification) {
      alert('缺失推送插件!');
      return;
    }
    pushNotification.register(
      function success(deviceToken) {
        if (typeof deviceToken === 'string' && deviceToken.length > 10) {
          // 成功获取到设备token
          window.localStorage.setItem('zf-ios-device-token', deviceToken);
        } else {
          // 第一次尝试获取不抛异常
        }
      },
      function fail(error) {
        alert(`获取设备Token过程异常!错误内容：${error.toString()}`);
      },
      {
        badge: 'true',
        sound: 'true',
        alert: 'true',
        ecb: 'onNotificationAPN'
      }
    );
  }
}

// iOS
function onNotificationAPN (event) {
	if ( event.alert )
	{
		navigator.notification.alert(event.alert);
	}

	if ( event.sound )
	{
		var snd = new Media(event.sound);
		snd.play();
	}

	if ( event.badge )
	{
		window.plugins?.pushNotification.setApplicationIconBadgeNumber(function successHandler(result){
      alert(result);
    }, function errorHandler(error){
      alert(error);
    }, event.badge);
	}
}

function open(url, params, payload) {
  if (params) {
    if (params === "_system") {
      window.location.href = url;
    } else {
      inAppBrowserRef.show();
      inAppBrowserRef.executeScript({
        code: 'window.JSBridge.receiveMessage(' + JSON.stringify(params) + ')'
      });
    }
  } else {
    if (window.cordova) {
      var str = navigator.userAgent.toLowerCase();
      var item = window.localStorage.getItem('gab-user-token');
      var userToken = '';
      // 如果有startTime的值，说明设置了失效时间
      if (item) {
        item = JSON.parse(item);
        if (item && item.startTime) {
          var date = new Date().getTime();
          // 如果大于就是过期了，如果小于或等于就还没过期
          if (date - item.startTime > item.expires) {
            localStorage.removeItem('gab-user-token');
          } else {
            userToken = item.value;
          }
        }
      }
      var options = 'location=yes,toolbarposition=top';
      if (payload) {
        options = 'location=yes,toolbarposition=top,token=' + userToken
          + ',sxjbxxid=' + payload.sxjbxxid
          + ',sclx=' + payload.sclx
          + ',env=' + payload.env
          + ',show=' + payload.show.replaceAll(',', '&');
        if (url.indexOf('?') > -1) {
          url += '&token=' + userToken
            + '&sxjbxxid=' + payload.sxjbxxid
            + '&sclx=' + payload.sclx
            + '&env=' + payload.env
            + '&show=' + payload.show;
        } else {
          url += '?token=' + userToken
            + '&sxjbxxid=' + payload.sxjbxxid
            + '&sclx=' + payload.sclx
            + '&env=' + payload.env
            + '&show=' + payload.show;
        }
      }
      if (str.match(/cpu iphone os (.*?) like mac os/)) {
        inAppBrowserRef = cordova.InAppBrowser.open(url, '_blank',
          options);
        inAppBrowserRef.addEventListener('exit', exit);
      } else {
        inAppBrowserRef = cordova.ThemeableBrowser.open(url, '_blank', {
          statusbar: {
            color: '#ffffff'
          },
          toolbar: {
            height: 80,
            color: '#ffffff'
          },
          title: {
            color: '#0A0A0A',
            showPageTitle: true,
            staticText: '公安一网通办'
          },
          backButton: {
            image: 'back_pressed',
            align: 'left',
            event: 'backPressed'
          },
          backButtonCanClose: true
        }).addEventListener('loadstart', loadStartCallBack)
          .addEventListener('loadstop', loadStopCallBack)
          .addEventListener('exit', exit);
      }
    } else {
      window.location.href = url;
    }
  }
}

function loadStartCallBack() {
  console.info('正在加载中');
}

function loadStopCallBack() {
  console.info('加载完毕');
}

function exit() {
  var str = window.location.href;
  if (str.indexOf('/login') >= 0) {//显示底部菜单按钮的页面
    history.back();
  }
  inAppBrowserRef.close();
}

function messageCallBack(params) {
  inAppBrowserRef.hide();
  var str = navigator.userAgent.toLowerCase();
  if (str.match(/cpu iphone os (.*?) like mac os/)) {
    location.href = "../www/index.html#/login?callbackUrl=" + params.callbackUrl + "&callbackId=" + params.callbackId;
  } else {
    window.location.href = "file:///android_asset/www/index.html#/android_asset/www/login?callbackId=" + params.callbackId + "&callbackUrl=" + encodeURIComponent(params.callbackUrl);
  }
}

function getID(params){
  window.localStorage.setItem("registrationID", params);
}

function downloadResult(params) {
  window.alert(params);
}

function onBackKeyDown() {
  if (!window.isscan) {
    var str = window.location.href;
    if (str.indexOf('/main') === -1) {//显示底部菜单按钮的页面
      history.back();
    } else if (str.indexOf('/main') >= 0) {
      if (exitAppTicker === 0) {
        exitAppTicker++;
        window.plugins.toast.showLongCenter('再按一次退出!');
        setTimeout(function () {
          exitAppTicker = 0;
        }, 2000);
      } else if (exitAppTicker === 1) {
        navigator.app.exitApp(); //退出app
      }
    }
  } else {
    window.isscan = false;
  }
}
