(function () {
  var id = 0,
    invokeCBMap = {},
    registerFuncs = {};
  window.JSBridge = {
    // 调用 Native
    invoke: function (bridgeName, callback, data) {
      var thisId = 'cb_' + (id++) + '_' + new Date().getTime();
      invokeCBMap[thisId] = callback;// 存储 Callback
      data.callbackId = thisId;
      data.callbackUrl = encodeURIComponent(location.href);
      data.method = bridgeName;
      var dataStr = data ? JSON.stringify(data) : "";
      window.prompt(dataStr, "gab-iab://:" + bridgeName);
    },
    receiveMessage: function (data) {
      var bridgeName = data.bridgeName,
        responstId = data.responstId;
      var callbackId = data.callbackId;
      if (callbackId) {
        var callback = invokeCBMap[callbackId];
        if (callback) {
          delete data.callbackId;
          invokeCBMap[callbackId](data);
          delete invokeCBMap[callbackId];
        } else {
          console.error('不存在该回调方法');
        }
      } else if (bridgeName) {
        if (registerFuncs[bridgeName]) { // 通过 bridgeName 找到句柄
          var ret = {},
            flag = false;
          registerFuncs[bridgeName].forEach((callback) => {
              callback(data, function (r) {
                flag = true;
                ret = Object.assign(ret, r);
              });
            }
          )
          if (flag) {
            nativeBridge.postMessage({ // 回调 Native
              responstId: responstId,
              ret: ret
            });
          }
        }
      }
    },
    register: function (bridgeName, callback) {
      if (!registerFuncs[bridgeName]) {
        registerFuncs[bridgeName] = [];
      }
      registerFuncs[bridgeName].push(callback); // 存储回调
    }
  };
})();

var GABSDK = {
  "userAuth": function (param, fn) {
    window.JSBridge.invoke("userAuth", fn, param);
  }
}
